#!/usr/bin/perl -w

# USE
use English;
use Getopt::Long;
use POSIX;

# DEFINES
my $start;
my $stop;
my $help;

$aanvalAppsDir = `cd \`dirname $0\`;pwd`;
chop($aanvalAppsDir);

$vMajor = 1;
$vMinor = 2;
$vBuild = 107;

# OPTIONS
GetOptions (
		'start' => \$start,
		'stop' => \$stop,
		'help' => \$help
		);
		
if (-e "$aanvalAppsDir/pidA") {
	system("rm -f $aanvalAppsDir/pidA");
	system("rm -f $aanvalAppsDir/pidB");
	system("rm -f $aanvalAppsDir/pidC");
}		
		
# Ready set go!
launch();		
		
sub launch {

	my $run = 1;

	print "---\nAanval Background Processing Unit (BPU) Initializer\nVersion: $vMajor.$vMinor.$vBuild\n---\n";

	# PERL TEST
	$command = "perl";
	for $dir (split /:/, $ENV{PATH}) { 
	   last if ($existsP = (-x "$dir/$command")); 
	} 
	die "Fatal Error -> '$command' command not found. Ensure this command is in your path before continuing.\n" unless ($existsP); 	
	
	# PHP TEST
	$command = "php";
	for $dir (split /:/, $ENV{PATH}) { 
	   last if ($existsP = (-x "$dir/$command")); 
	} 
	die "Fatal Error -> '$command' command not found. Ensure this command is in your path before continuing.\n" unless ($existsP); 		
	
	if ($stop) {
		system("touch $aanvalAppsDir/pid/allStop");
		print "BPU STOP Requested\n";
		print "STOP command issued to all BPU's ... please wait ...\n";
		sleep(5);
		print "Finished (5 Seconds Remain)\n";
		sleep(5);
		exit;
	}
	
	# Exit immediately if this launch isn't going anywhere
	if (!$start && !$help) { print "\nNothing to do. Try -help\n\n"; $run = 0; }
	
	# Display Help
	if ($help) { displayHelp(); $run = 0; }

	if ($run == 1) {
		
		# Remove allStop semaphore if exists
		if (-e "$aanvalAppsDir/pid/allStop") {
			system("rm -f $aanvalAppsDir/pid/allStop");
		}

        system("perl $aanvalAppsDir/processorA.pl -start");
        system("perl $aanvalAppsDir/processorB.pl -start");
        system("perl $aanvalAppsDir/processorC.pl -start");
        
        # Removed Deprecated BPU D
		if (-e "$aanvalAppsDir/processorD.pl") {
			system("rm -f $aanvalAppsDir/processorD.pl");
			system("rm -f $aanvalAppsDir/processorD.php");
		}
        
	}

	exit;
}

sub displayHelp {

	print "Usage: perl idsBackground.pl [options]\n\n";
	
	print "-start       Start all Aanval Background Processors\n";
	print "-stop        Stop all Aanval Background Processors\n";
	print "-help        This Help Information\n";
	print "\n";
	print "Example: perl idsBackground.pl -start\n";
	print "\n";

}
